import torch

class Graph:
    def __init__(self,**kwargs):
        if('edge_index' in kwargs):
            self.nmap = kwargs.get('edge_index')
        if('edge_attr' in kwargs):
            self.nmap = kwargs.get('edge_attr')
        if('node_attr' in kwargs):
            self.nmap = kwargs.get('node_attr')
        if('y' in kwargs):
            self.nmap = kwargs.get('y')
'''
edge_index srcId,dstId 全图部分
nmap real_id -> node_attr_id  
emap real_id -> edge_attr_id 
npart node_id->part_id
epart edge_id->part_id
'''      
class DistGraph(Graph):
    def __init__(self,**kwargs):
        if('nmap' in kwargs):
            self.nmap = kwargs.get('nmap')
        if('emap' in kwargs):
            self.nmap = kwargs.get('emap')
        if('npart' in kwargs):
            self.nmap = kwargs.get('npart')
        if('epart' in kwargs):
            self.nmap = kwargs.get('epart')
        if(kwargs):
            super(Graph,self).__init__(kwargs)

    def get_node_num(self):    
        return self.adj.size(0)

    def load_graph(self,path):
        print(" load graph ",path)
        adj,data,partptr,perm =torch.load(path)
        self.adj=adj
        self.data=data #maybe nmap
        self.partptr=partptr
        self.perm=perm

    def get_part_num(self):
        return self.data.x.size()[0]

    def select_attr(self,index):
        return torch.index_select(self.data.x,0,index)
    #返回全局的节点id 所对应的分区
    def get_part(self,index):
        print(index)
        return torch.index_select(self.partptr,0,index)

    

