import argparse
import torch.distributed as dist
import os
from itertools import count
import torch.multiprocessing as mp
import torch
import torch.distributed.rpc as rpc
import torch.optim as optim
from torch.distributed.rpc import RRef, rpc_async, remote
from torch.distributions import Categorical
import torch.multiprocessing as mp
from message_worker import DistributedDataLoader, sampler_worker
from RpcAgent import Agent
from Sample.Sampler import NeighborSampler
import message_worker
OBSERVER_NAME='server{}'

parser = argparse.ArgumentParser(
    description="RPC Reinforcement Learning Example",
    formatter_class=argparse.ArgumentDefaultsHelpFormatter,
)

parser.add_argument('--world_size', default=4, type=int, metavar='W',
                    help='number of workers')
parser.add_argument('--log_interval', type=int, default=10, metavar='N',
                    help='interval between training status logs')
parser.add_argument('--gamma', type=float, default=0.99, metavar='G',
                    help='how much to value future rewards')
parser.add_argument('--seed', type=int, default=1, metavar='S',
                    help='random seed  for reproducibility')
args = parser.parse_args()

def init_distribution(rank,world_size):
    os.environ['MASTER_ADDR']='localhost'
    os.environ['MASTER_PORT']='29000'
    dist.init_process_group(backend="gloo", world_size=world_size, rank=rank)
    rpc.init_rpc(OBSERVER_NAME.format(rank),rank=rank,world_size=world_size)
    if(rank==0):
        message_worker.init_sampler_worker()
    dist.barrier()
    print(OBSERVER_NAME.format(rank))
    #worker = sampler_worker(world_size,OBSERVER_NAME)
    #if(rank==0):
    #rrefs = 
    #master_worker = sampler_worker(world_size,OBSERVER_NAME)

def close_distribution():
    #message_worker.set_sampler_worker_none()
    rpc.shutdown()

def main(rank,world_size=2):
    init_distribution(rank,world_size)
    sampler=NeighborSampler()
    loader=DistributedDataLoader('test','./part/metis_4',sampler,num_samples=100,num_neighbors=30)
    print(next(loader))
    close_distribution()

if __name__ == '__main__':
    mp.spawn(
        main,
        args=(4, ),
        nprocs=4,
        join=True
    )
